"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = require("react");

var _fastJsonStableStringify = _interopRequireDefault(require("fast-json-stable-stringify"));

var _reverseArgs = _interopRequireDefault(require("../utils/reverseArgs"));

var _attachmentsAsUint8Arrays = _interopRequireDefault(require("../attachmentsAsUint8Arrays"));

var _changes = _interopRequireDefault(require("../changes"));

var _useDB = _interopRequireDefault(require("../useDB"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var UINT8ARRAY = 'u8a';
/**
 * Converts all attachments of a document into Uint8Arrays, if the binary option is set.
 * @param {boolean} binary Should the attachments be converted into an Uint8Array.
 * @param {object} doc The document.
 */

function formatDocAttachments(_x, _x2) {
  return _formatDocAttachments.apply(this, arguments);
}
/**
 * Transforms a change object into a row object.
 * @param {boolean} includeDocs Should documents be included in the allDocs result.
 * @param {boolean} binary Should the attachments be converted into an Uint8Array.
 * @param {object} change PouchDB-Change-Object.
 */


function _formatDocAttachments() {
  _formatDocAttachments = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4(binary, doc) {
    return _regenerator.default.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (!(binary && doc && !doc._deleted && '_attachments' in doc)) {
              _context5.next = 11;
              break;
            }

            _context5.t1 = _objectSpread;
            _context5.t2 = {};
            _context5.t3 = doc;
            _context5.next = 6;
            return (0, _attachmentsAsUint8Arrays.default)(doc._attachments);

          case 6:
            _context5.t4 = _context5.sent;
            _context5.t5 = {
              _attachments: _context5.t4
            };
            _context5.t0 = (0, _context5.t1)(_context5.t2, _context5.t3, _context5.t5);
            _context5.next = 12;
            break;

          case 11:
            _context5.t0 = doc;

          case 12:
            return _context5.abrupt("return", _context5.t0);

          case 13:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee4);
  }));
  return _formatDocAttachments.apply(this, arguments);
}

function transformToRow(_x3, _x4, _x5) {
  return _transformToRow.apply(this, arguments);
}
/**
 * Converts all attachments into Uint8Arrays.
 * The rows will be updated in place, while the documents are copied.
 * @param {Object[]} rows Rows that should be updated IN PLACE.
 */


function _transformToRow() {
  _transformToRow = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(includeDocs, binary, change) {
    return _regenerator.default.wrap(function _callee5$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.t0 = change.id;
            _context6.t1 = change.id;
            _context6.t2 = change.changes[0];

            if (!(includeDocs && change.doc)) {
              _context6.next = 9;
              break;
            }

            _context6.next = 6;
            return formatDocAttachments(binary, change.doc);

          case 6:
            _context6.t3 = _context6.sent;
            _context6.next = 10;
            break;

          case 9:
            _context6.t3 = undefined;

          case 10:
            _context6.t4 = _context6.t3;
            return _context6.abrupt("return", {
              id: _context6.t0,
              key: _context6.t1,
              value: _context6.t2,
              doc: _context6.t4
            });

          case 12:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee5);
  }));
  return _transformToRow.apply(this, arguments);
}

function formatRowsAttachments(binary, rows) {
  // The mapped value is the Promise. The rows will be updated in place!
  var converting = rows.map(
  /*#__PURE__*/
  function () {
    var _ref = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee(row) {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(row.doc && row.doc._attachments)) {
                _context.next = 4;
                break;
              }

              _context.next = 3;
              return formatDocAttachments(binary, row.doc);

            case 3:
              row.doc = _context.sent;

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x6) {
      return _ref.apply(this, arguments);
    };
  }());
  return Promise.all(converting);
}

var _default = function _default(useListen) {
  return (0, _reverseArgs.default)(function useAllDocs() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var db = arguments.length > 1 ? arguments[1] : undefined;
    db = (0, _useDB.default)(db, {
      callee: 'useAllDocs',
      example: 'useAllDocs(db, options)'
    });
    var startkey = options.startkey,
        endkey = options.endkey,
        descending = options.descending,
        attachments = options.attachments,
        limit = options.limit,
        skip = options.skip,
        otherOptions = (0, _objectWithoutProperties2.default)(options, ["startkey", "endkey", "descending", "attachments", "limit", "skip"]);
    var binary = attachments === UINT8ARRAY;
    var optionsWithAttachmentAndBinaryOption = (0, _react.useMemo)(function () {
      return _objectSpread({
        // binary option will be overwritten by otherOptions.binary
        // so that a Blob can be used.
        binary: binary,
        startkey: startkey,
        endkey: endkey,
        descending: descending,
        limit: limit,
        skip: skip
      }, otherOptions, {
        attachments: !!attachments
      });
    }, [binary, startkey, endkey, descending, limit, skip, (0, _fastJsonStableStringify.default)(otherOptions), !!attachments]);
    var keysMode = options.keys != null;
    var keyMode = options.key != null;
    var changesOptions = (0, _react.useMemo)(function () {
      var changesOptions = {
        live: true,
        include_docs: optionsWithAttachmentAndBinaryOption.include_docs,
        since: 'now',
        // Documents are kept in memory. 'complete' event can return an empty array.
        return_docs: false
      }; // add keys/key to only subscribe to those.

      if (keyMode) {
        changesOptions.doc_ids = [optionsWithAttachmentAndBinaryOption.key];
      } else if (keysMode) {
        changesOptions.doc_ids = optionsWithAttachmentAndBinaryOption.keys;
      }

      return changesOptions;
    }, [optionsWithAttachmentAndBinaryOption, keysMode, keyMode]);
    return useListen(db, options,
    /*#__PURE__*/
    function () {
      var _ref2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(setValue) {
        var _context2;

        var _ref3, rows, update, toRow;

        return _regenerator.default.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return db.allDocs(optionsWithAttachmentAndBinaryOption);

              case 2:
                _ref3 = _context4.sent;
                rows = _ref3.rows;

                if (!binary) {
                  _context4.next = 7;
                  break;
                }

                _context4.next = 7;
                return formatRowsAttachments(binary, rows);

              case 7:
                update = function update() {
                  return setValue((0, _toConsumableArray2.default)(rows));
                };

                update();
                toRow = transformToRow.bind(null, options.include_docs, binary);
                return _context4.abrupt("return", (_context2 = db, _changes.default).call(_context2, changesOptions,
                /*#__PURE__*/
                function () {
                  var _ref4 = (0, _asyncToGenerator2.default)(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee2(change) {
                    var id, deleted, index, found, lastId, replacementRows, _replacementRows, insertIndex;

                    return _regenerator.default.wrap(function _callee2$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            id = change.id, deleted = change.deleted; // guards that check if the document's id is between startkey and endkey.
                            // But only if they exist.

                            if (!(startkey != null && (descending && id > startkey || !descending && id < startkey))) {
                              _context3.next = 3;
                              break;
                            }

                            return _context3.abrupt("return");

                          case 3:
                            if (!(endkey != null && (descending && id < endkey || !descending && id > endkey || // if inclusive_end is omitted, it defaults to true
                            options.inclusive_end === false && endkey === id))) {
                              _context3.next = 5;
                              break;
                            }

                            return _context3.abrupt("return");

                          case 5:
                            index = rows.findIndex(function (row) {
                              return row.id === id;
                            });
                            found = index !== -1; // Document was deleted

                            if (!deleted) {
                              _context3.next = 32;
                              break;
                            }

                            if (!found) {
                              _context3.next = 30;
                              break;
                            }

                            // remove row
                            rows.splice(index, 1); // ranges mode (with startkey and endkey)
                            // If it was on the limit load the next row/document.

                            if (!(rows.length + 1 === limit && !keysMode && !keyMode)) {
                              _context3.next = 21;
                              break;
                            }

                            lastId = rows[rows.length - 1].id;
                            _context3.next = 14;
                            return db.allDocs(_objectSpread({}, optionsWithAttachmentAndBinaryOption, {
                              startkey: lastId,
                              skip: 1,
                              limit: 1
                            }));

                          case 14:
                            replacementRows = _context3.sent;

                            if (!binary) {
                              _context3.next = 18;
                              break;
                            }

                            _context3.next = 18;
                            return formatRowsAttachments(binary, replacementRows.rows);

                          case 18:
                            rows.push.apply(rows, (0, _toConsumableArray2.default)(replacementRows.rows));
                            _context3.next = 29;
                            break;

                          case 21:
                            if (!(keysMode && !keyMode)) {
                              _context3.next = 29;
                              break;
                            }

                            _context3.next = 24;
                            return db.allDocs(_objectSpread({}, optionsWithAttachmentAndBinaryOption, {
                              keys: [id]
                            }));

                          case 24:
                            _replacementRows = _context3.sent;

                            if (!binary) {
                              _context3.next = 28;
                              break;
                            }

                            _context3.next = 28;
                            return formatRowsAttachments(binary, _replacementRows.rows);

                          case 28:
                            rows.splice.apply(rows, [index, 0].concat((0, _toConsumableArray2.default)(_replacementRows.rows)));

                          case 29:
                            update();

                          case 30:
                            _context3.next = 52;
                            break;

                          case 32:
                            if (!found) {
                              _context3.next = 39;
                              break;
                            }

                            _context3.next = 35;
                            return toRow(change);

                          case 35:
                            rows[index] = _context3.sent;
                            update();
                            _context3.next = 52;
                            break;

                          case 39:
                            // add the new row
                            insertIndex = rows.findIndex(descending ? function (row) {
                              return row.id < id;
                            } // if descending find the first row with a smaller id
                            : function (row) {
                              return row.id > id;
                            } // else find the first row with a bigger id
                            );

                            if (!(insertIndex === -1)) {
                              _context3.next = 44;
                              break;
                            }

                            if (!(limit != null && rows.length === limit)) {
                              _context3.next = 43;
                              break;
                            }

                            return _context3.abrupt("return");

                          case 43:
                            insertIndex = rows.length;

                          case 44:
                            _context3.t0 = rows;
                            _context3.t1 = insertIndex;
                            _context3.next = 48;
                            return toRow(change);

                          case 48:
                            _context3.t2 = _context3.sent;

                            _context3.t0.splice.call(_context3.t0, _context3.t1, 0, _context3.t2);

                            if (limit != null && rows.length > limit) {
                              // remove the last row if the limit was exceeded.
                              rows.pop();
                            }

                            update();

                          case 52:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  return function (_x8) {
                    return _ref4.apply(this, arguments);
                  };
                }()));

              case 11:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee3);
      }));

      return function (_x7) {
        return _ref2.apply(this, arguments);
      };
    }());
  });
};

exports.default = _default;
//# sourceMappingURL=useAllDocs.js.map